////////////////////////////
//
//	Clip-4-Win DEVMODE definitions
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.
//	All Rights Reserved.
//
//	For use with, e.g. CreateDC().
//
////////////////////////////

#ifndef	C4W_PRINT_CH
#define	C4W_PRINT_CH


// Array elements of aDevMode[], which can be passed to CreateDC(),
// DeviceCapabilities() or ExtDeviceMode() to control printers
// (actually, a2bin(aDevMode, DM_IN_DEF) is passed)
//
// (these correspond to the members of the Windows DEVMODE structure)

#define	DM_DeviceName		1	// 32-char name (null-padded on input)
#define	DM_SpecVersion		2	// 
#define	DM_DriverVersion	3	// 
#define	DM_Size			4	// 
#define	DM_DriverExtra		5	// 
#define	DM_Fields		6	// 
#define	DM_Orientation		7	// 
#define	DM_PaperSize		8	// 
#define	DM_PaperLength		9	// 
#define	DM_PaperWidth		10	// 
#define	DM_Scale		11	// 
#define	DM_Copies		12	// 
#define	DM_DefaultSource	13	// 
#define	DM_PrintQuality		14	// 
#define	DM_Color		15	// 
#define	DM_Duplex		16	// 
#define	DM_YResolution		17	// 
#define	DM_TTOption		18	// 
// The rest of the structure is device-dependent
#define	DM_DeviceDependent	19	// treated as a Clipper string

#define	DM_LENGTH	19	// length of array

#define	CCHDEVICENAME	32

// These do not include the DM_DeviceDependent info
#define	DM_IN_DEF	"str,uint[4],long,int[12],str"	// for a2bin()
#define	DM_OUT_DEF	"str[32],uint[4],long,int[12]"	// for bin2a()


// Fields
#define	DM_ORIENTATION		1
#define	DM_PAPERSIZE		2
#define	DM_PAPERLENGTH		4
#define	DM_PAPERWIDTH		8
#define	DM_SCALE		16
#define	DM_COPIES		256
#define	DM_DEFAULTSOURCE	512
#define	DM_PRINTQUALITY		1024
#define	DM_COLOR		2048
#define	DM_DUPLEX		4096
#define	DM_YRESOLUTION		8192
#define	DM_TTOPTION		16384

// Orientation options
#define	DMORIENT_PORTRAIT	1
#define	DMORIENT_LANDSCAPE	2

// Paper options
#define	DMPAPER_LETTER		1
#define	DMPAPER_A3		8
#define	DMPAPER_A4		9
#define	DMPAPER_A4SMALL		10
#define	DMPAPER_A5		11
#define	DMPAPER_ENV_C5		28
#define	DMPAPER_ENV_C3		29
#define	DMPAPER_ENV_C4		30
#define	DMPAPER_ENV_C6		31
#define	DMPAPER_ENV_C65		32
#define	DMPAPER_ENV_B4		33
#define	DMPAPER_ENV_B5		34
#define	DMPAPER_ENV_B6		35

// Print resolution options
#define	DMRES_DRAFT	(-1)
#define	DMRES_LOW	(-2)
#define	DMRES_MEDIUM	(-3)
#define	DMRES_HIGH	(-4)

// TrueType options
#define	DMTT_BITMAP	1	// print TT fonts as graphics
#define	DMTT_DOWNLOAD	2	// download TT fonts as soft fonts
#define	DMTT_SUBDEV	3	// substitute device fonts for TT fonts

// Mode options
#define	DM_UPDATE	1
#define	DM_COPY		2
#define	DM_PROMPT	4
#define	DM_MODIFY	8

#define	DM_IN_BUFFER	DM_MODIFY
#define	DM_IN_PROMPT	DM_PROMPT
#define	DM_OUT_BUFFER	DM_COPY
#define	DM_OUT_DEFAULT	DM_UPDATE


// Exported ordinals
#define	PROC_EXTDEVICEMODE	(90)
#define	PROC_DEVICECAPABILITIES	(91)
#define	PROC_OLDDEVICEMODE	(13)


#endif	// C4W_PRINT_CH
